import math
import threading, time, random

array = []

def compute_function(thread_index):
  sum = 0
  for i in range(0,10000):
    for j in range(0,5000):
      sum += math.cos(i) * math.sin(j)
  array.append(thread_index)
  
def run_threads(num_threads):
  global array

  begin = time.time()
  print(f"Starting {num_threads} threads...", end='', flush=True)
  threads = []
  for thread_index in range(num_threads):
    individual_thread = threading.Thread(target=compute_function, args=(thread_index,))
    threads.append(individual_thread)
    individual_thread.start()

  for individual_thread in threads:
    individual_thread.join()

  end = time.time()
  print(f"done in {(end - begin):.2f} seconds")
  print(array)
  array = []


if __name__ == "__main__":
  run_threads(1)
  run_threads(2)
  run_threads(4)
